function x=mb2bin(mat)
% This function converts the matrix of binary bits with MSB at the lowest
% column and LSB at the highest column. For example if we have matrix (mat)
% as [0 1] then 0 is the MSB and 1 is the LSB. Also note that the input
% should be a matrix of size 1*n, where n is the no. of bits. Then the
% output of the function gives 01.
sz=size(mat);
sum=0;
for i=1:sz(1,2)
    sum=mat(1,sz(1,2)-i+1)*2^(i-1)+sum;
end
x=sum;
%dec2bin(sum,sz(1,2));