function [src_des,num_of_inter]=nxt(sp,dp,N)
% This function evaluates the all possible interfering signals for given
% siwtch and primary signal. sp= source port of the  primary signal.
% dp=destination port of the primary signal. N switch size.SI is the set of
% source ports of interfering signals. DI is the set of destination ports of the
% interfering signals. N ishould be power of 2.
%clc
M=log2(N); % This is the minimum number of bits required to represent N.
%spd=dec2bin(sp-1,M); % This is source number for the primary source in binary system with minimum number of bits M. 
                      % Here we have subtracted one from source port number of primary signal
%dpd=dec2bin(dp-1,M); %destination of the primary port in binary form
spi=zeros(1,M); % this is the martix with each element being the bit values of the sp indvidually. 
dpi=zeros(1,M); % Similary for destination.
sn=sp-1;
dn=dp-1;
for i=1:M
    spi(1,M-i+1)=rem(sn,2);
    dpi(1,M-i+1)=rem(dn,2);
    sn=floor(sn/2);
    dn=floor(dn/2);
end
for i=1:M
    if i==1
       si(1,M-i+1)=bitcmp(spi(1,M-i+1),1);
       for i1=2:M
           si(1,M-i1+1)=spi(1,M-i1+1);
       end
       SI(1,1)=mb2bin(si)+1;
    else
        for j=1:i-1
            si(1,M-j+1)=0; 
        end
        si(1,M-i+1)=bitcmp(spi(1,M-i+1),1);
        for k=i+1:M
            si(1,M-k+1)=spi(1,M-k+1);
        end
        SI(1,i)=mb2bin(si)+1;
    end
    
end
%SI; % This matrix gives the interfering source port numbers. This is the row 
    % matrix with no. of columns being the max no. of interfering sources
%--------------------------------------------------------------------------
for i=1:M
    if i==1
       if ((dp-1)>=0)||((dp-1)<=N-1)
          di(1,M-i+1)=bitcmp(dpi(1,M-i+1),1);
          for i1=2:M
              di(1,M-i1+1)=dpi(1,M-i1+1);
          end
          %di;
          DI(1,1)=mb2bin(di)+1;
       else
       end
    else
        if mod((dp-1),2^(i-1))==0
           di=zeros(1,M);
           di(1,M-i+1)=bitcmp(dpi(1,M-i+1),1);
           for k=i+1:M
               di(1,M-k+1)=dpi(1,M-k+1);
           end
           %di;
           mat=num_bin(i-1,M); % This is the matrix that is of size 2^(i-1)*(i-1) which has all the
                               %  different posible binary numbers for i-1
           sz=size(mat);
           appen=zeros(sz(1,1),M);
           for k1=1:sz(1,1)
               for k2=1:M
                   appen(k1,k2)=di(1,k2);
               end
           end
           fin_mat=appen+mat;
           sz1=size(fin_mat);
           for k1=1:sz1(1,1)
               for k2=1:sz1(1,2)
                   con_mat(1,k2)=fin_mat(k1,k2);
               end
               DI=[DI mb2bin(con_mat)+1];
           end
        else
        end
    end
end              
%DI; % This matrix gives the interfering destination port numbers. This is 
    %  the row matrix with no. of columns being the max no. of interfering sources
%--------------------------------------------------------------------------
% sz2=size(SI);
% sz3=size(DI);
% src_des=zeros(sz2(1,2)*sz3(1,2),2);
src_des=zeros(length(SI)*length(DI),2);
for k0=0:length(SI)-1
    for k1=1:length(DI)
        src_des(k1+length(DI)*k0,2)=DI(1,k1);
        src_des(k1+length(DI)*k0,1)=SI(1,k0+1);
    end
end
num_of_inter=length(src_des); % This is number of possible interfering channels
%src_des; % This is the matrix which gives the source -> destination pairs of the interfering channels. That is 
         %  src_des(i,1)=source port number, src_des(i,2)=destination port no. 1<=i<=m*n (where m = no. of
         %  interfering sources n= no. of  interfering destination  port numbers.)
% fprintf(' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n' )
% fprintf(' Primary Source    -->   Primary Destination \n' )
% fprintf(' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n' )
% fprintf('       %i            -->          %i \n'  ,sp,dp)
% fprintf(' -----------------------------------------------------------\n' )
% fprintf('  All possible Interfering Signals for given primary signal \n ')
% fprintf(' -----------------------------------------------------------\n' )
% fprintf('  Interfering Source  -->    Interfering Destination        \n' )
% fprintf(' -----------------------------------------------------------\n' )
% for k1=1:length(SI)*length(DI)
%     fprintf('      %i              -->          %i                       \n ', src_des(k1,1),src_des(k1,2))
% end
% fprintf(' -----------------------------------------------------------\n' )