function [DisMat, number_of_links,nds,num_of_wavelengths,q_th,max_degree,RT_METHOD,num_of_des,wave_assginment,tau_th]=constants(Topo_No)
[DisMat,number_of_links,nds,max_degree]=phy_topology(Topo_No);
% input=fopen('InputParam.txt','r'); % Opens the input file
% InputData=fscanf(input,'%f',[1,inf]); % Reads the input file and creates a row matrix for the input data.
load InputParam.txt; % Loads the values in the InputParam.txt and assigns a variable InputParam
% Remember to write the input data in a row matrix form
% Input Data should be of the order: 1) Number of Requests
%                                    2) Topology Number
%                                    3) Number of Wavelengths
%                                    4) Q-factor threshold
%                                    5) Routing Method
%                                    6) Lower limit (Network Load)
%                                    7) Increment Network Load
%                                    8) Upper limit Network Load
%                                    9) Probable number of destinations (set D_s)
%                                   10) Wavelength Assginment (Random -1; First Fit -2)
%                                   11) Latency Threshold (tau_LP+tau_pd <=tau_th)
num_of_wavelengths=InputParam(3); % Number of wavelengths used in the network
q_th=InputParam(4); % Q-factor threshold
%%%%%%% Give the Routing method to used %%%%
% 1 = Minimum Distance
% 2 = Minimum Hop
RT_METHOD=InputParam(5);
num_of_des=InputParam(9);
wave_assginment=InputParam(10);
tau_th=InputParam(11); % latency threshold for the LP in seconds
%fclose(input);
