function [time_next_event,LinkStatusMat,DeptMat,oxc_sw_stat,oxc_sw_pwr,add_ports,drop_ports,LOG_MAT]=depart(time_next_event,LinkStatusMat,DeptMat,Topo_No,...
                                                                                                   oxc_sw_stat,oxc_sw_pwr,add_ports,drop_ports,FiberPort,RT_METHOD,LOG_MAT,MAX_NDS)
[DisMat, number_of_links,nds,num_of_wavelengths,q_th,max_degree,RT_METHOD,num_of_des]=constants(Topo_No);
for i=1:nds
    for j=1:nds
        for k=1:num_of_wavelengths
            if time_next_event(2)==DeptMat(i,j,k,1)
               SrcNd=i;
               DesNd=j;
               wave_no=k;
               DEPT_REQ_ID=DeptMat(i,j,k,2);
            end
        end
    end
end
sz=size(LOG_MAT);
rws_LOG=sz(1,1); % Collecting the size of the Rows for the LOG_MAT
rm_row=zeros(1,MAX_NDS+4); % This is row that collectes the information about the request that is departing
if DEPT_REQ_ID==0
    % There is soemthing Wrong !
    error('There is soemthing Wrong !');
else
   for i=1:rws_LOG
       if LOG_MAT(i,1)==DEPT_REQ_ID
          for j=1:MAX_NDS+4
              rm_row(j)=LOG_MAT(i,j); % This collects all the information from where the request is departing
          end
          LOG_MAT(i,:)=[]; % Removing the row from the LOG_MAT
          break; % Once the information is collected then the outer for loop is exited
       end
   end 
end
%rm_row;
for i=2:MAX_NDS+1
    if (rm_row(i)~=0)
       Route(i-1)=rm_row(i);
    else
        break;
    end
end
if (Route(1)~=SrcNd) || (Route(length(Route))~=DesNd)
   error('There is soemthing Wrong !');
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Route;
[oxc_sw_stat,oxc_sw_pwr,add_ports,drop_ports]=deconfigOXC(oxc_sw_stat,oxc_sw_pwr,Route,wave_no,FiberPort,max_degree,add_ports,drop_ports);
% for i=length(Route)
%     oxc_sw_pwr(:,:,wave_no,Route(i)) %% Just to check % Comment it later
%     oxc_sw_stat(:,:,wave_no,Route(i))
% end
DeptMat(SrcNd,DesNd,wave_no,1)=inf;
DeptMat(SrcNd,DesNd,wave_no,2)=0; % Removing the REQ_ID
LinkStatusMat(Route(1),Route(2),wave_no)=0;
for h=2:length(Route)-1
    LinkStatusMat(Route(h),Route(h+1),wave_no)=0;
end
time_next_event(2)=min(min(min(DeptMat(:,:,:,1))));% After finding the time at which the departure occurs, we can make the next event departure time as Inf.
                       % Making the server Idle.
%server_idle_time=time_next_event(1)-sim_time; % This the duration the server is idle