function bin=num_bin(a,n)
% This function gives all the possible binary numbers for the given a. In
% the other words, if a=3, then the outputs are 000, 001,.....111. These
% are stored in the matrix bin where each element represents element in the
% matrix represents the bit. For example, [0 0 0; 0 0 1; 0 1 0; .......;1 1
% 1]. This is a 8*3 matrix.
bin=zeros(2^a,n);
k=0:(2^a-1);
for i=1:2^a
    for j=1:a
        bin(i,n-j+1)=rem(k(1,i),2);
        k(1,i)=floor(k(1,i)/2);
    end
end