function [SortDesNds]=sorting(SrcNd,DesNds,Topo_No,DisMat,num_of_des,RT_METHOD)
%RT_METHOD=1 for shortest path
%RT_METHOD=2 for minimum hop
%[DisMat, number_of_links,nds,num_of_wavelengths,q_th,max_degree,RT_METHOD,num_of_des]=constants(Topo_No);
dis=zeros(1,num_of_des); % This is value of the cost function to reach each destination in DesNds set. 
% In the case of Shortest Path this value is total distance in the shortest Route
% In case of Minimum Hop routing, this value is the number of hops
for i=1:length(DesNds)
    Route =dijkstra(SrcNd,DesNds(i),Topo_No,RT_METHOD);
    switch RT_METHOD
        case 1,
            j=1;
            while(j<length(Route))
                  dis(i)=dis(i)+DisMat(Route(j),Route(j+1));
                  j=j+1;
            end
        case 2,
            dis(i)=length(Route)-1; % Since in this case it the number of hops
    end    
end
%dis
SortDesNds=zeros(1,length(DesNds));
%SortDis=zeros(1,length(DesNds));
j=0;
while(~isempty(dis))
    min=Inf;
    for i=1:length(dis)
        if dis(i)<min
            min=dis(i);
            min_des=DesNds(i);
        else
        end
    end
    j=j+1;
   % SortDis(j)=min;
    SortDesNds(j)=min_des;
    for i=1:length(dis)
       if (dis(i)==min)
           dis(i)=[];
           DesNds(i)=[];
           break % break the for loop
       end
    end
end
     