function [sim_time,next_event_type,time_next_event]=timing(time_next_event,num_events)
% This function determines what is next type of event that occurs. That is the it is the minium
% value in the event list.  There are only two events possible 1.arrival or 2.departure.
% So if the next_event_type=1, then the event that % happens next is an arrival if next_event_type=2, then it's departure.
next_event_type=0;
i=1; 
min_time_next_event=Inf;
while i<=num_events
    if (time_next_event(i)<min_time_next_event)
        min_time_next_event=time_next_event(i);
        next_event_type=i;
    else
        if (next_event_type==0)
          error(' Event List is Empty');
        else
        end
    end
    i=i+1;
end
sim_time=min_time_next_event;