function [max_avail_wave,avail_wave,wave_no]=wave_assign(LinkStatusMat, Route,num_of_wavelengths,wave_assignment)
%[DisMat, number_of_links,nds,num_of_des,sel_of_des,nf_th,delay_th]=constants(Topo_No);
% This program calculates the number of wavelengths free for the a selected
% source-destination pair. It outputs the number of wavelengths avaiable
% free 
result=0;
max_avail_wave=0;
avail_wave=0; % Intialization
wave_no=0;
%avail_wave=zeros(1,num_of_wavelengths); % This is array consisting of 1,0's. 1 indicates available for assignment and 0 not available for assignment. 
for i=1:num_of_wavelengths
    for j=1:length(Route)-1
        result=result+LinkStatusMat(Route(j),Route(j+1),i); % 1=USED; 0=UNUSED
    end
    if result==0 % Wavelength is available free on all the links of the path thus maintaining WCC
       max_avail_wave=max_avail_wave+1;
       avail_wave(1,max_avail_wave)=i; %#ok<AGROW> % ith wavelength is avialable for assignment. Note avail_wave Indicates the array of wavelength indexs available
    else
        result=0; % Making sure that the result is assinged back to zero, and then evalute the status of other wavelengths in the list
    end
end
if max_avail_wave~=0
    switch wave_assignment
        case 1
                rd_array=randperm(length(avail_wave));
                rd_idx=rd_array(1); % Selecting a random index for the wavelength
                wave_no=avail_wave(rd_idx); % This is wavelength number that is selected randomly other words, wavelength index
        case 2
                wave_no=avail_wave(1); % Selecting the first wavelengths based on the wavelength number
    end
end       